diff -Naur gcc-4.5.4.orig/ChangeLog gcc-4.5.4/ChangeLog
--- gcc-4.5.4.orig/ChangeLog	2012-07-02 11:24:45.000000000 +0200
+++ gcc-4.5.4/ChangeLog	2013-11-04 10:10:10.628472871 +0100
@@ -2,6 +2,15 @@
 
 	* GCC 4.5.4 released.
 
+2012-05-09  Nick Clifton  <nickc@redhat.com>
+	    Paul Smith  <psmith@gnu.org>
+
+	PR bootstrap/50461
+	* configure.ac (mpfr-dir): When using in-tree MPFR sources
+	allow for the fact that from release v3.1.0 of MPFR the source
+	files were moved into a src sub-directory.
+	* configure: Regenerate.
+
 2011-12-18  Eric Botcazou  <ebotcazou@adacore.com>
 
 	* configure: Regenerate.
diff -Naur gcc-4.5.4.orig/ChangeLog.rtems gcc-4.5.4/ChangeLog.rtems
--- gcc-4.5.4.orig/ChangeLog.rtems	1970-01-01 01:00:00.000000000 +0100
+++ gcc-4.5.4/ChangeLog.rtems	2013-11-04 10:10:10.628472871 +0100
@@ -0,0 +1,4 @@
+2008-02-05	Ralf Corsépius <ralf.corsepius@rtems.org>
+
+	* configure, configure.ac (skipdirs): Add target-libiberty.
+
diff -Naur gcc-4.5.4.orig/configure.ac gcc-4.5.4/configure.ac
--- gcc-4.5.4.orig/configure.ac	2011-06-27 23:02:53.000000000 +0200
+++ gcc-4.5.4/configure.ac	2013-11-04 10:10:10.633472956 +0100
@@ -527,6 +527,7 @@
     noconfigdirs="$noconfigdirs target-newlib target-libgloss ${libgcj} target-libmudflap"
     ;;
   *-*-rtems*)
+    skipdirs="$skipdirs target-libiberty"
     noconfigdirs="$noconfigdirs target-libgloss ${libgcj}"
     ;;
     # The tpf target doesn't support gdb yet.
@@ -1299,9 +1300,16 @@
   gmplibs="-L$with_mpfr_lib $gmplibs"
 fi
 if test "x$with_mpfr$with_mpfr_include$with_mpfr_lib" = x && test -d ${srcdir}/mpfr; then
-  gmplibs='-L$$r/$(HOST_SUBDIR)/mpfr/'"$lt_cv_objdir $gmplibs"
-  gmpinc='-I$$r/$(HOST_SUBDIR)/mpfr -I$$s/mpfr '"$gmpinc"
-  extra_mpc_mpfr_configure_flags='--with-mpfr-include=$$s/mpfr --with-mpfr-lib=$$r/$(HOST_SUBDIR)/mpfr/'"$lt_cv_objdir"
+  # MPFR v3.1.0 moved the sources into a src sub-directory.
+  if test -d ${srcdir}/mpfr/src; then
+    gmplibs='-L$$r/$(HOST_SUBDIR)/mpfr/src/'"$lt_cv_objdir $gmplibs"
+    gmpinc='-I$$r/$(HOST_SUBDIR)/mpfr/src -I$$s/mpfr/src '"$gmpinc"
+    extra_mpc_mpfr_configure_flags='--with-mpfr-include=$$s/mpfr/src --with-mpfr-lib=$$r/$(HOST_SUBDIR)/mpfr/src/'"$lt_cv_objdir"
+  else
+    gmplibs='-L$$r/$(HOST_SUBDIR)/mpfr/'"$lt_cv_objdir $gmplibs"
+    gmpinc='-I$$r/$(HOST_SUBDIR)/mpfr -I$$s/mpfr '"$gmpinc"
+    extra_mpc_mpfr_configure_flags='--with-mpfr-include=$$s/mpfr --with-mpfr-lib=$$r/$(HOST_SUBDIR)/mpfr/'"$lt_cv_objdir"
+  fi
   # Do not test the mpfr version.  Assume that it is sufficient, since
   # it is in the source tree, and the library has not been built yet
   # but it would be included on the link line in the version check below
@@ -3008,7 +3016,7 @@
        # to it.  This is right: we don't want to search that directory
        # for binaries, but we want the header files in there, so add
        # them explicitly.
-       FLAGS_FOR_TARGET=$FLAGS_FOR_TARGET' -isystem $$r/$(HOST_SUBDIR)/gcc/include'
+       FLAGS_FOR_TARGET=$FLAGS_FOR_TARGET' -isystem $$r/$(HOST_SUBDIR)/gcc/include -isystem $$r/$(HOST_SUBDIR)/gcc/include-fixed'
 
        # Someone might think of using the pre-installed headers on
        # Canadian crosses, in case the installed compiler is not fully
diff -Naur gcc-4.5.4.orig/gcc/ChangeLog.rtems gcc-4.5.4/gcc/ChangeLog.rtems
--- gcc-4.5.4.orig/gcc/ChangeLog.rtems	1970-01-01 01:00:00.000000000 +0100
+++ gcc-4.5.4/gcc/ChangeLog.rtems	2013-11-04 10:10:10.633472956 +0100
@@ -0,0 +1,68 @@
+2013-07-08	Ralf Corsépius <ralf.corsepius@rtems.org>
+
+	* doc/cppopts.texi, doc/generic.texi, doc/invoke.texi:
+	Hacks to get docs building with texinfo-5.
+
+2011-09-05	Ralf Corsépius <ralf.corsepius@rtems.org>
+
+	* config/lm32/t-rtems: New.
+	* config.gcc (lm32-*-rtems*): Add lm32/t-rtems.
+
+2011-02-20	Ralf Corsépius <ralf.corsepius@rtems.org>
+
+	* config/rs6000/t-rtems: Add -mcpu=8540/-mfloat-gprs=double multilib.
+
+2011-02-20	Ralf Corsépius <ralf.corsepius@rtems.org>
+
+	* config/rs6000/t-rtems: Remove -mcpu=601 multilib.
+	* config/rs6000/t-rtems: Remove -Dmpc8260 multilib.
+	* config/rs6000/rtems.h: Allow --float-gprs=... to override grps on
+	E500 targets.
+
+2010-05-19  Joel Sherrill <joel.sherrill@oarcorp.com>
+
+    	* config.gcc (sparc64-*-rtems*): New target.
+	* config/sparc/sp64-rtemself.h: New file.
+
+2010-04-19	Ralf Corsépius <ralf.corsepius@rtems.org>
+
+	* ginclude/stddef.h: Define _MACHINE_ANSI_H_ if _X86_64_ANSI_H_ is 
+	defined (Used by amd64-*-netbsdelf5.*).
+
+2010-04-18	Ralf Corsépius <ralf.corsepius@rtems.org>
+
+	* ginclude/stddef.h: Define _MACHINE_ANSI_H_ if _I386_ANSI_H_ is 
+	defined (Used by i386-*-netbsdelf5.*).
+
+2010-03-15	Ralf Corsépius <ralf.corsepius@rtems.org>
+
+	Patch from Thomas Doerfler <Thomas.Doerfler@embedded-brains.de>:
+	* config/arm/rtems-elf.h, config/arm/t-rtems: Add optional support
+	for vfp FPU model
+
+2009-12-01	Ralf Corsépius <ralf.corsepius@rtems.org>
+
+	* config/avr/avr.h (LINK_SPEC): Pass -m avrN to ld for -mmcu=avrN.
+
+2009-11-04	Ralf Corsépius <ralf.corsepius@rtems.org>
+
+	* config/m32c/rtems.h, config/m68k/rtemself.h,
+	config/m68k/rtemself.h, config/sh/rtemself.h,
+	config/sparc/rtemself.h: Undef WCHAR_TYPE_SIZE, WCHAR_TYPE. 
+	(Resets WCHAR_TYPE's to defaults. Prevents broken GCC tm_files 
+	to interfere and cause wchar_t/wint_t incompatibilities).
+
+2009-10-15	Ralf Corsépius <ralf.corsepius@rtems.org>
+
+	* config/avr/t-rtems: Don't build _exit.
+
+		Ralf Corsépius <ralf.corsepius@rtems.org>
+
+	* config/rs6000/rtems.h: Support for custom RTEMS multilibs.
+	Support TARGET_E500.
+	* config/rs6000/t-rtems: Custom RTEMS multilibs. 
+
+		Ralf Corsépius <ralf.corsepius@rtems.org>
+
+	* config/mips/elf.h: Remove NO_IMPLICIT_EXTERN_C.
+	
diff -Naur gcc-4.5.4.orig/gcc/config/arm/rtems-elf.h gcc-4.5.4/gcc/config/arm/rtems-elf.h
--- gcc-4.5.4.orig/gcc/config/arm/rtems-elf.h	2009-03-25 13:54:16.000000000 +0100
+++ gcc-4.5.4/gcc/config/arm/rtems-elf.h	2013-11-04 10:10:10.634472973 +0100
@@ -36,7 +36,7 @@
  */
 #undef SUBTARGET_EXTRA_ASM_SPEC
 #define SUBTARGET_EXTRA_ASM_SPEC "\
-  %{!mhard-float: %{!msoft-float:-mfpu=softfpa}}"
+  %{!mhard-float: %{!mfpu=vfp: %{!msoft-float:-mfpu=softfpa}}}"
 
 /*
  *  The default includes --start-group and --end-group which conflicts
diff -Naur gcc-4.5.4.orig/gcc/config/arm/t-rtems gcc-4.5.4/gcc/config/arm/t-rtems
--- gcc-4.5.4.orig/gcc/config/arm/t-rtems	2004-11-23 06:30:32.000000000 +0100
+++ gcc-4.5.4/gcc/config/arm/t-rtems	2013-11-04 10:10:10.634472973 +0100
@@ -5,6 +5,41 @@
 MULTILIB_EXCEPTIONS  = 
 MULTILIB_MATCHES     = marm=mno-thumb
 
-MULTILIB_OPTIONS    += msoft-float/mhard-float
-MULTILIB_DIRNAMES   += soft fpu
-MULTILIB_EXCEPTIONS += *mthumb/*mhard-float*
+MULTILIB_OPTIONS    += mhard-float/mfloat-abi=softfp
+MULTILIB_DIRNAMES   += fpu softfp
+MULTILIB_EXCEPTIONS += *mthumb*/*mhard-float* *mthumb*/*mfloat-abi=softfp*
+MULTILIB_MATCHES     =
+
+MULTILIB_OPTIONS    += mfpu=vfp
+MULTILIB_DIRNAMES   += vfp
+MULTILIB_EXCEPTIONS += *mhard-float*/*mfpu=vfp* *marm*/*mfloat-abi=softfp*/*mfpu=fpa*
+MULTILIB_EXCLUSIONS += !mthumb/mfloat-abi=softfp/!mfpu=vfp
+
+# default float model is fpa, so don't create a explicit copy of it
+MULTILIB_EXCEPTIONS += *marm*/*mfpa*
+
+# permutations of the options which are useful (+) or make no sense (-),
+# defaults are in brackets:
+# + (arm/soft/fpa)
+# + (arm/soft)/vfp
+# - (arm)/softfp(/fpa)
+# + (arm)/softfp/vfp
+# + (arm)/hard-float(/fpa)
+# - (arm)/hard-float/vfp
+# + thumb/(soft/fpa)
+# + thumb/(soft/)vfp
+# - thumb/softfp/fpa
+# - thumb/softfp/vfp
+# - thumb/hard-float/fpa
+# - thumb/hard-float/vfp
+
+# subdirs to be used for multilibs and their respective options:
+#/thumb/vfp  -> thumb/soft/vfp
+#/thumb/fpa  -> thumb/soft/fpa
+#/thumb      -> thumb/soft/fpa
+#/vfp        -> arm/soft/vfp
+#/softfp/vfp -> arm/softfp/cfp
+#/fpu/fpa    -> arm/hard/fpa
+#/fpu        -> arm/hard/fpa
+#/fpa        -> arm/soft/fpa
+#.           -> arm/soft/fpa
diff -Naur gcc-4.5.4.orig/gcc/config/avr/t-rtems gcc-4.5.4/gcc/config/avr/t-rtems
--- gcc-4.5.4.orig/gcc/config/avr/t-rtems	2004-11-23 04:44:03.000000000 +0100
+++ gcc-4.5.4/gcc/config/avr/t-rtems	2013-11-04 10:10:10.634472973 +0100
@@ -1,3 +1,4 @@
 # Multilibs for avr RTEMS targets.
 
-# ATM, this is just a stub
+# RTEMS uses _exit from newlib
+LIB1ASMFUNCS := $(filter-out _exit,$(LIB1ASMFUNCS))
diff -Naur gcc-4.5.4.orig/gcc/config/lm32/t-rtems gcc-4.5.4/gcc/config/lm32/t-rtems
--- gcc-4.5.4.orig/gcc/config/lm32/t-rtems	1970-01-01 01:00:00.000000000 +0100
+++ gcc-4.5.4/gcc/config/lm32/t-rtems	2013-11-04 10:10:10.635472991 +0100
@@ -0,0 +1,21 @@
+# for multilib
+MULTILIB_OPTIONS = mmultiply-enabled mbarrel-shift-enabled
+MULTILIB_OPTIONS += mdivide-enabled msign-extend-enabled
+
+MULTILIB_EXCEPTIONS =
+# MULTILIB_EXCEPTIONS += mmultiply-enabled/mbarrel-shift-enabled/mdivide-enabled/msign-extend-enabled
+MULTILIB_EXCEPTIONS += mmultiply-enabled/mbarrel-shift-enabled/mdivide-enabled
+MULTILIB_EXCEPTIONS += mmultiply-enabled/mbarrel-shift-enabled/msign-extend-enabled
+#MULTILIB_EXCEPTIONS += mmultiply-enabled/mbarrel-shift-enabled
+MULTILIB_EXCEPTIONS += mmultiply-enabled/mdivide-enabled/msign-extend-enabled
+MULTILIB_EXCEPTIONS += mmultiply-enabled/mdivide-enabled
+MULTILIB_EXCEPTIONS += mmultiply-enabled/msign-extend-enabled
+# MULTILIB_EXCEPTIONS += mmultiply-enabled
+MULTILIB_EXCEPTIONS += mbarrel-shift-enabled/mdivide-enabled/msign-extend-enabled
+MULTILIB_EXCEPTIONS += mbarrel-shift-enabled/mdivide-enabled
+MULTILIB_EXCEPTIONS += mbarrel-shift-enabled/msign-extend-enabled
+# MULTILIB_EXCEPTIONS += mbarrel-shift-enabled
+MULTILIB_EXCEPTIONS += mdivide-enabled/msign-extend-enabled
+MULTILIB_EXCEPTIONS += mdivide-enabled
+MULTILIB_EXCEPTIONS += msign-extend-enabled
+# MULTILIB_EXCEPTIONS += 
diff -Naur gcc-4.5.4.orig/gcc/config/m32c/rtems.h gcc-4.5.4/gcc/config/m32c/rtems.h
--- gcc-4.5.4.orig/gcc/config/m32c/rtems.h	2008-12-01 17:34:42.000000000 +0100
+++ gcc-4.5.4/gcc/config/m32c/rtems.h	2013-11-04 10:10:10.635472991 +0100
@@ -29,5 +29,9 @@
     }						\
   while (0)
 
-/* Use the default */
+/* Use the defaults */
 #undef LINK_GCC_C_SEQUENCE_SPEC
+
+#undef WCHAR_TYPE
+
+#undef WCHAR_TYPE_SIZE
diff -Naur gcc-4.5.4.orig/gcc/config/m68k/rtemself.h gcc-4.5.4/gcc/config/m68k/rtemself.h
--- gcc-4.5.4.orig/gcc/config/m68k/rtemself.h	2007-08-02 12:49:31.000000000 +0200
+++ gcc-4.5.4/gcc/config/m68k/rtemself.h	2013-11-04 10:10:10.635472991 +0100
@@ -31,3 +31,8 @@
 	builtin_assert ("system=rtems");	\
     }						\
   while (0)
+
+/* Use the defaults */
+#undef WCHAR_TYPE
+
+#undef WCHAR_TYPE_SIZE
diff -Naur gcc-4.5.4.orig/gcc/config/mips/elf.h gcc-4.5.4/gcc/config/mips/elf.h
--- gcc-4.5.4.orig/gcc/config/mips/elf.h	2007-08-02 12:49:31.000000000 +0200
+++ gcc-4.5.4/gcc/config/mips/elf.h	2013-11-04 10:10:10.635472991 +0100
@@ -48,6 +48,4 @@
 #undef  ENDFILE_SPEC
 #define ENDFILE_SPEC "crtend%O%s crtn%O%s"
 
-#define NO_IMPLICIT_EXTERN_C 1
-
 #define HANDLE_PRAGMA_PACK_PUSH_POP 1
diff -Naur gcc-4.5.4.orig/gcc/config/rs6000/rtems.h gcc-4.5.4/gcc/config/rs6000/rtems.h
--- gcc-4.5.4.orig/gcc/config/rs6000/rtems.h	2007-08-02 12:49:31.000000000 +0200
+++ gcc-4.5.4/gcc/config/rs6000/rtems.h	2013-11-04 10:10:10.635472991 +0100
@@ -49,8 +49,23 @@
 %{mcpu=604:  %{!Dppc*: %{!Dmpc*: -Dmpc604}  } } \
 %{mcpu=750:  %{!Dppc*: %{!Dmpc*: -Dmpc750}  } } \
 %{mcpu=821:  %{!Dppc*: %{!Dmpc*: -Dmpc821}  } } \
-%{mcpu=860:  %{!Dppc*: %{!Dmpc*: -Dmpc860}  } }" 
+%{mcpu=860:  %{!Dppc*: %{!Dmpc*: -Dmpc860}  } } \
+%{mcpu=8540: %{!Dppc*: %{!Dmpc*: -Dppc8540}  } }" 
 
 #undef  SUBSUBTARGET_EXTRA_SPECS
 #define SUBSUBTARGET_EXTRA_SPECS \
   { "cpp_os_rtems",		CPP_OS_RTEMS_SPEC }
+
+#undef SUBSUBTARGET_OVERRIDE_OPTIONS
+#define SUBSUBTARGET_OVERRIDE_OPTIONS			\
+  do {							\
+    if (TARGET_E500)					\
+      {							\
+        if (!rs6000_explicit_options.float_gprs)	\
+          rs6000_float_gprs = 1; 			\
+      }							\
+  } while(0)
+
+#undef WCHAR_TYPE
+
+#undef WCHAR_TYPE_SIZE
diff -Naur gcc-4.5.4.orig/gcc/config/rs6000/t-rtems gcc-4.5.4/gcc/config/rs6000/t-rtems
--- gcc-4.5.4.orig/gcc/config/rs6000/t-rtems	2009-04-21 21:03:23.000000000 +0200
+++ gcc-4.5.4/gcc/config/rs6000/t-rtems	2013-11-04 10:10:10.636473009 +0100
@@ -19,14 +19,12 @@
 # <http://www.gnu.org/licenses/>.
 
 MULTILIB_OPTIONS	= \
-mcpu=403/mcpu=505/mcpu=601/mcpu=603e/mcpu=604/mcpu=860/mcpu=7400 \
-Dmpc8260 \
-msoft-float
+mcpu=403/mcpu=505/mcpu=603e/mcpu=604/mcpu=860/mcpu=7400/mcpu=8540 \
+msoft-float/mfloat-gprs=double
 
 MULTILIB_DIRNAMES	= \
-m403 m505 m601 m603e m604 m860 m7400 \
-mpc8260 \
-nof
+m403 m505 m603e m604 m860 m7400 m8540 \
+nof gprsdouble
 
 # MULTILIB_MATCHES	= ${MULTILIB_MATCHES_FLOAT}
 MULTILIB_MATCHES	=
@@ -47,6 +45,13 @@
 # Map 750 to .
 MULTILIB_MATCHES	+= mcpu?750=
 
+# Map 8548 to 8540
+MULTILIB_MATCHES	+= mcpu?8540=mcpu?8548
+
+# Map -mcpu=8540 -mfloat-gprs=single to -mcpu=8540
+# (mfloat-gprs=single is implicit default)
+MULTILIB_MATCHES	+= mcpu?8540=mcpu?8540/mfloat-gprs?single
+
 # Soft-float only, default implies msoft-float
 # NOTE: Must match with MULTILIB_MATCHES_FLOAT and MULTILIB_MATCHES
 MULTILIB_SOFTFLOAT_ONLY = \
@@ -62,6 +67,16 @@
 MULTILIB_HARDFLOAT_ONLY = \
 *mcpu=505/*msoft-float*
 
+# Targets which do not support gprs
+MULTILIB_NOGPRS = \
+mfloat-gprs=* \
+*mcpu=403/*mfloat-gprs=* \
+*mcpu=505/*mfloat-gprs=* \
+*mcpu=603e/*mfloat-gprs=* \
+*mcpu=604/*mfloat-gprs=* \
+*mcpu=860/*mfloat-gprs=* \
+*mcpu=7400/*mfloat-gprs=*
+
 MULTILIB_EXCEPTIONS =
 
 # Disallow -Dppc and -Dmpc without other options
@@ -69,14 +84,8 @@
 
 MULTILIB_EXCEPTIONS	+= \
 ${MULTILIB_SOFTFLOAT_ONLY} \
-${MULTILIB_HARDFLOAT_ONLY}
+${MULTILIB_HARDFLOAT_ONLY} \
+${MULTILIB_NOGPRS}
 
 # Special rules
 # Take out all variants we don't want
-MULTILIB_EXCEPTIONS += *mcpu=403/Dmpc*
-MULTILIB_EXCEPTIONS += *mcpu=505/Dmpc*
-MULTILIB_EXCEPTIONS += *mcpu=601/Dmpc*
-MULTILIB_EXCEPTIONS += *mcpu=604/Dmpc*
-MULTILIB_EXCEPTIONS += *mcpu=750/Dmpc*
-MULTILIB_EXCEPTIONS += *mcpu=860/Dmpc*
-MULTILIB_EXCEPTIONS += *mcpu=7400/Dmpc*
diff -Naur gcc-4.5.4.orig/gcc/config/sh/rtemself.h gcc-4.5.4/gcc/config/sh/rtemself.h
--- gcc-4.5.4.orig/gcc/config/sh/rtemself.h	2007-08-02 12:49:31.000000000 +0200
+++ gcc-4.5.4/gcc/config/sh/rtemself.h	2013-11-04 10:10:10.636473009 +0100
@@ -24,3 +24,8 @@
   builtin_define( "__rtems__" );		\
   builtin_assert( "system=rtems" );		\
 } while (0)
+
+/* Use the defaults */
+#undef WCHAR_TYPE
+
+#undef WCHAR_TYPE_SIZE
diff -Naur gcc-4.5.4.orig/gcc/config/sparc/rtemself.h gcc-4.5.4/gcc/config/sparc/rtemself.h
--- gcc-4.5.4.orig/gcc/config/sparc/rtemself.h	2007-08-02 12:49:31.000000000 +0200
+++ gcc-4.5.4/gcc/config/sparc/rtemself.h	2013-11-04 10:10:10.636473009 +0100
@@ -29,5 +29,9 @@
     }						\
   while (0)
 
-/* Use the default */
+/* Use the defaults */
 #undef LINK_GCC_C_SEQUENCE_SPEC
+
+#undef WCHAR_TYPE
+
+#undef WCHAR_TYPE_SIZE
diff -Naur gcc-4.5.4.orig/gcc/config/sparc/sp64-rtemself.h gcc-4.5.4/gcc/config/sparc/sp64-rtemself.h
--- gcc-4.5.4.orig/gcc/config/sparc/sp64-rtemself.h	1970-01-01 01:00:00.000000000 +0100
+++ gcc-4.5.4/gcc/config/sparc/sp64-rtemself.h	2013-11-04 10:10:10.636473009 +0100
@@ -0,0 +1,37 @@
+/* Definitions for rtems targeting a SPARC64 using ELF.
+   Copyright (C) 2010 Free Software Foundation, Inc.
+   Contributed by Joel Sherrill (joel@OARcorp.com).
+
+This file is part of GCC.
+
+GCC is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 3, or (at your option)
+any later version.
+
+GCC is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GCC; see the file COPYING3.  If not see
+<http://www.gnu.org/licenses/>.  */
+
+/* Target OS builtins.  */
+#undef TARGET_OS_CPP_BUILTINS
+#define TARGET_OS_CPP_BUILTINS()		\
+  do						\
+    {						\
+	builtin_define ("__rtems__");		\
+	builtin_define ("__USE_INIT_FINI__");	\
+	builtin_assert ("system=rtems");	\
+    }						\
+  while (0)
+
+/* Use the default */
+#undef LINK_GCC_C_SEQUENCE_SPEC
+
+/* we are not svr4 */
+#undef CPP_SUBTARGET_SPEC
+#define CPP_SUBTARGET_SPEC ""
diff -Naur gcc-4.5.4.orig/gcc/config.gcc gcc-4.5.4/gcc/config.gcc
--- gcc-4.5.4.orig/gcc/config.gcc	2012-06-04 11:55:35.000000000 +0200
+++ gcc-4.5.4/gcc/config.gcc	2013-11-04 10:10:10.634472973 +0100
@@ -1526,7 +1526,7 @@
 lm32-*-rtems*)
 	tm_file="dbxelf.h elfos.h ${tm_file} lm32/rtems.h rtems.h newlib-stdint.h"
 	tmake_file="${tmake_file} lm32/t-lm32 lm32/t-fprules-softfp soft-fp/t-softfp"
-	tmake_file="${tmake_file} t-rtems"
+	tmake_file="${tmake_file} t-rtems lm32/t-rtems"
          ;;
 lm32-*-uclinux*)
         tm_file="dbxelf.h elfos.h ${tm_file} linux.h lm32/uclinux-elf.h"
@@ -2408,6 +2408,12 @@
 	tmake_file="sparc/t-elf sparc/t-crtfm t-rtems"
 	extra_parts="crti.o crtn.o crtbegin.o crtend.o"
 	;;
+sparc64-*-rtems*)
+	tm_file="${tm_file} dbxelf.h elfos.h svr4.h newlib-stdint.h sparc/sysv4.h sparc/sp64-elf.h sparc/sp64-rtemself.h rtems.h"
+	extra_options="${extra_options} sparc/little-endian.opt"
+	tmake_file="${tmake_file} sparc/t-crtfm t-rtems"
+	extra_parts="crtbegin.o crtend.o"
+	;;
 sparc*-*-solaris2*)
 	tm_file="sparc/biarch64.h ${tm_file} dbxelf.h elfos.h svr4.h sparc/sysv4.h sol2.h"
 	case ${target} in
diff -Naur gcc-4.5.4.orig/gcc/ginclude/stddef.h gcc-4.5.4/gcc/ginclude/stddef.h
--- gcc-4.5.4.orig/gcc/ginclude/stddef.h	2009-04-09 17:00:19.000000000 +0200
+++ gcc-4.5.4/gcc/ginclude/stddef.h	2013-11-04 10:10:10.641473093 +0100
@@ -53,7 +53,13 @@
    one less case to deal with in the following.  */
 #if defined (__BSD_NET2__) || defined (____386BSD____) || (defined (__FreeBSD__) && (__FreeBSD__ < 5)) || defined(__NetBSD__)
 #include <machine/ansi.h>
+#if !defined(_MACHINE_ANSI_H_)
+#if defined(_I386_ANSI_H_) || defined(_X86_64_ANSI_H_)
+#define _MACHINE_ANSI_H_
 #endif
+#endif
+#endif
+
 /* On FreeBSD 5, machine/ansi.h does not exist anymore... */
 #if defined (__FreeBSD__) && (__FreeBSD__ >= 5)
 #include <sys/_types.h>
diff -Naur gcc-4.5.4.orig/libgcc/ChangeLog.rtems gcc-4.5.4/libgcc/ChangeLog.rtems
--- gcc-4.5.4.orig/libgcc/ChangeLog.rtems	1970-01-01 01:00:00.000000000 +0100
+++ gcc-4.5.4/libgcc/ChangeLog.rtems	2013-11-04 10:10:10.642473111 +0100
@@ -0,0 +1,9 @@
+2010-08-17  Ralf Corsépius <ralf.corsepius@rtems.org>
+
+	1669/Tools, GCC-BZ 44793
+	* config.host (powerpc-*-rtems*): Add tmake_file.
+	Add extra_parts.
+
+2010-05-19  Joel Sherrill <joel.sherrill@oarcorp.com>
+
+	* config.host (sparc64-*-rtems*): New target.
diff -Naur gcc-4.5.4.orig/libgcc/config.host gcc-4.5.4/libgcc/config.host
--- gcc-4.5.4.orig/libgcc/config.host	2011-08-24 20:03:50.000000000 +0200
+++ gcc-4.5.4/libgcc/config.host	2013-11-04 10:10:10.642473111 +0100
@@ -470,6 +470,8 @@
 	tmake_file="${tmake_file} rs6000/t-ppccomm"
 	;;
 powerpc-*-rtems*)
+	tmake_file="${tmake_file} rs6000/t-ppccomm t-softfp"
+	extra_parts="crtbegin.o crtend.o crtbeginS.o crtendS.o crtbeginT.o"
 	;;
 powerpc-*-linux* | powerpc64-*-linux*)
 	tmake_file="${tmake_file} rs6000/t-ppccomm rs6000/t-ldbl128 t-softfp"
@@ -539,7 +541,7 @@
 	extra_parts="$extra_parts crtfastmath.o"
 	tmake_file="${tmake_file} sparc/t-crtfm"
 	;;
-sparc-*-rtems*)
+sparc-*-rtems* | sparc64-*-rtems* )
 	;;
 sparc64-*-solaris2* | sparcv9-*-solaris2*)
 	;;
diff -Naur gcc-4.5.4.orig/libstdc++-v3/crossconfig.m4 gcc-4.5.4/libstdc++-v3/crossconfig.m4
--- gcc-4.5.4.orig/libstdc++-v3/crossconfig.m4	2009-06-02 21:15:03.000000000 +0200
+++ gcc-4.5.4/libstdc++-v3/crossconfig.m4	2013-11-04 10:10:10.654473315 +0100
@@ -198,6 +198,12 @@
     AC_DEFINE(HAVE_SINHF)
     AC_DEFINE(HAVE_SINHL)
     ;;
+  *-rtems*)
+    GLIBCXX_CHECK_COMPILER_FEATURES
+    GLIBCXX_CHECK_LINKER_FEATURES
+    GLIBCXX_CHECK_MATH_SUPPORT
+    GLIBCXX_CHECK_STDLIB_SUPPORT
+    ;;
   *-solaris*)
     case "$target" in
       *-solaris2.7 | *-solaris2.8 | *-solaris2.9 | *-solaris2.10)
